#include <p18cxxx.h>
#define  USE_AND_MASKS
#include <pconfig.h>	// choix des fonctions en fonction du type de pic
#include <delays.h>
#include <stdio.h>
#include <timers.h>		// Timers
#include <usart.h>		// RS232
#include <adc.h>	
#include "can.h"
#include "commun.h"
#include "HardwareProfile.h"				

#pragma config OSC = INTIO67
#pragma config WDT=OFF		// whatch dog
#pragma config LVP=OFF

#define rel1 PORTCbits.RC2
#define rel2 PORTCbits.RC3
#define led1 PORTCbits.RC0
#define led2 PORTCbits.RC1

hhll ValCan;
unsigned int mesure;
char nb [10];
char text[10];
char trame[5];
char car;
unsigned char P;
/***********************************************************************************************/
//  IUT_Bluetooth  D.NARDI avec code de scurit   2 relais
/***********************************************************************************************/
void Setup(void)
{
	TRISA=0x0f;				// Port A E_S
	TRISC=0;				// Port C en Sortie
	TRISB=0xFF;				// PortB en entre	

	OSCCON=0x70;			// 0 111 00 0 00pas de prdiviseur => 8MHz horloge interne
	OSCTUNE=0x40;			// PLL ON Fosc x 4 = 32MHz
	ADCON1=0x0D;			// AN0 AN1 = A toutes les autres entres en analogique D 
	INTCON2bits.RBPU = 0;	// PullUP PortB ON	
	// Initialisation du CAN
    OpenADC(ADC_FOSC_32      &
    		ADC_RIGHT_JUST   &
			ADC_12_TAD,
			ADC_CH0          &	
			ADC_REF_VDD_VSS  &
			ADC_INT_OFF, ADC_1ANA );

	// Initialisation de la liaison srie  115200b/s
	OpenUSART( 	USART_TX_INT_OFF  &
            	USART_RX_INT_OFF  &
            	USART_ASYNCH_MODE &		// mode asynchrone
            	USART_EIGHT_BIT   &		// 8bits
            	USART_CONT_RX     &           	
				USART_BRGH_HIGH,16);  	// [(32000000/115200)/16]-1 = 16

	rel1=0;rel2=0;led2=1;led1=1;
}					
/************************************************************************/
// Affiche Volts et dizime de volt
/************************************************************************/
void Aff_Volt (char *txt,unsigned char val)
{
    Dec255 (txt,val/10);
    Dec255 (nb,val%10);
    ConCatROM (txt,".");
    ConCatRAM (txt,nb);
    ConCatROM (txt," V");
    Bourrer(txt,16);
}
/************************************************************************/
void conversion(void)
{
		demConv=1;                       // Mesure de la tension batterie
    	while (busyCAN);                        
   	 	ValCan.w8.H=ADRESH; ValCan.w8.L=ADRESL; 
    	mesure= ValCan.w16;
		P =mesure/6.82;
		Aff_Volt (text,P);
}
/************************************************************************/
void main(void)
{	
	char i;
    Delay10KTCYx(10);
	Setup();
	SetChanADC( ADC_CH0 );
	led1=!led1;Delay10KTCYx(100);Delay10KTCYx(100);	// cligno led x3
	led1=!led1;Delay10KTCYx(100);Delay10KTCYx(100);
	led1=!led1;Delay10KTCYx(100);Delay10KTCYx(100);
	led1=!led1;Delay10KTCYx(100);Delay10KTCYx(100);
	led1=!led1;Delay10KTCYx(100);Delay10KTCYx(100);
	led1=1;
/************************************************************************/
	for(;;)
	{
		do
		{
			while (!DataRdyUSART());	// reception
			car = ReadUSART();	
		}
		while (car!=0xff);				// attend le debut de trame FFh
		trame[0]=car;
		for (i=1;i<4;i++)
		{
			while (!DataRdyUSART());	// reception trame
			trame[i] = ReadUSART();	
		}
/**********************************************************************************************/
		if((trame[1]==42)&&(trame[2]==56))	// Vrification du code de scurit 4256 decimal
		{
			switch (trame[3])
			{
				case 0x30: {rel1=1;led1=0;break;}
				case 0x31: {rel1=0;led1=1;break;}
				case 0x32: {rel2=1;led2=0;break;}
				case 0x33: {rel2=0;led2=1;break;}	
				case 0x38: {rel1=0;rel2=0;led1=1;led2=1;break;}	
			}
		}
/*********************************************************************************************/
		CloseUSART();
		conversion();	// lecture tension batterie
		OpenUSART( 	USART_TX_INT_OFF  &
           USART_RX_INT_OFF  &
           USART_ASYNCH_MODE &		
           USART_EIGHT_BIT   &	
           USART_CONT_RX     &           	
		   USART_BRGH_HIGH,16); 		

		printf(" ");	// transmission vers BT de la tension batterie
        for(i=0; i<6; i++) printf("%c",text[i]);
		printf("\r");
/*********************************************************************************************/
	}
}
